import 'package:get_cli/commands/impl/commads_export.dart';
import 'package:get_cli/commands/impl/install/install_get.dart';
import 'package:get_cli/common/utils/logger/LogUtils.dart';
import 'package:get_cli/functions/create/create_main.dart';
import 'package:get_cli/samples/impl/get_app_pages.dart';
import 'package:get_cli/samples/impl/get_route.dart';
import 'package:get_cli/samples/impl/getx_pattern/get_main.dart';

Future<void> createInitGetxPattern() async {
  bool canContinue = await createMain();
  if (!canContinue) return;

  await Future.wait([
    GetXMainSample().create(),
    RouteSample().create(),
    AppPagesSample().create(),
    CreatePageCommand().execute(),
  ]);
  await installGet();

  LogService.success('GetX Pattern structure successfully generated.');
}
